'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

exports.guessCorrectValue = guessCorrectValue;
exports.useEventTargetValue = useEventTargetValue;
exports.useFirstArgument = useFirstArgument;
exports.useSecondArgument = useSecondArgument;
exports.useThirdArgument = useThirdArgument;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _lodash = require('lodash.set');

var _lodash2 = _interopRequireDefault(_lodash);

var _lodash3 = require('lodash.unset');

var _lodash4 = _interopRequireDefault(_lodash3);

var _lodash5 = require('lodash.get');

var _lodash6 = _interopRequireDefault(_lodash5);

var _lodash7 = require('lodash.drop');

var _lodash8 = _interopRequireDefault(_lodash7);

var _lodash9 = require('lodash.has');

var _lodash10 = _interopRequireDefault(_lodash9);

var _lodash11 = require('lodash.isstring');

var _lodash12 = _interopRequireDefault(_lodash11);

var _lodash13 = require('lodash.isplainobject');

var _lodash14 = _interopRequireDefault(_lodash13);

var _lodash15 = require('lodash.reduce');

var _lodash16 = _interopRequireDefault(_lodash15);

var _lodash17 = require('lodash.defaultsdeep');

var _lodash18 = _interopRequireDefault(_lodash17);

var _lodash19 = require('lodash.clonedeep');

var _lodash20 = _interopRequireDefault(_lodash19);

var _lodash21 = require('lodash.foreach');

var _lodash22 = _interopRequireDefault(_lodash21);

var _lodash23 = require('lodash.map');

var _lodash24 = _interopRequireDefault(_lodash23);

var _invariant = require('invariant');

var _invariant2 = _interopRequireDefault(_invariant);

var _emptyFunc = require('./utils/emptyFunc');

var _emptyFunc2 = _interopRequireDefault(_emptyFunc);

var _arrayFrom = require('./utils/arrayFrom');

var _arrayFrom2 = _interopRequireDefault(_arrayFrom);

var _pickDeep = require('./utils/pickDeep');

var _pickDeep2 = _interopRequireDefault(_pickDeep);

var _pickOutermost = require('./utils/pickOutermost');

var _pickOutermost2 = _interopRequireDefault(_pickOutermost);

var _mergeValidatedValuePaths = require('./utils/mergeValidatedValuePaths');

var _mergeValidatedValuePaths2 = _interopRequireDefault(_mergeValidatedValuePaths);

var _valuesWithDefaultsAndExemptions = require('./utils/valuesWithDefaultsAndExemptions');

var _valuesWithDefaultsAndExemptions2 = _interopRequireDefault(_valuesWithDefaultsAndExemptions);

var _Wildcard = require('./constants/Wildcard');

var _Wildcard2 = _interopRequireDefault(_Wildcard);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

var Joi = void 0;

var DEFAULT_STATE = {
  errors: {},
  values: {},
  touchedValues: {},
  validatedValues: {},
  changingValues: [],

  validateAllValues: false
};

function guessCorrectValue(event, value) {
  var eventTargetValue = (0, _lodash6.default)(event, 'target.value');

  if (eventTargetValue) {
    return eventTargetValue;
  } else {
    return value;
  }
}

function useEventTargetValue(event) {
  return (0, _lodash6.default)(event, 'target.value');
}

function useFirstArgument(value) {
  return value;
}

function useSecondArgument(arg1, value) {
  return value;
}

function useThirdArgument(arg1, arg2, value) {
  return value;
}

var defaultChangeHandlerStrategy = guessCorrectValue;

var ReactJoiValidation = function ReactJoiValidation(ValidatedComponent, _ref) {
  var joiSchema = _ref.joiSchema,
      joiOptions = _ref.joiOptions,
      validator = _ref.validator,
      only = _ref.only,
      _ref$pseudoValues = _ref.pseudoValues,
      pseudoValues = _ref$pseudoValues === undefined ? [] : _ref$pseudoValues,
      externalErrorsPath = _ref.externalErrorsPath,
      changeHandlerStrategy = _ref.changeHandlerStrategy;

  function usingSingularValidationScope() {
    return (0, _lodash12.default)(only);
  }

  function wrapObject(object) {
    if (usingSingularValidationScope()) {
      return (0, _lodash2.default)({}, only, object);
    } else {
      return object;
    }
  }

  function unwrapObject(object) {
    if (usingSingularValidationScope()) {
      return (0, _lodash6.default)(object, only);
    } else {
      return object;
    }
  }

  function pickErrors(errors, touchedValues) {

    var listOfTouchedValues = (0, _pickOutermost2.default)(touchedValues);

    var valuesToPick = [].concat(_toConsumableArray(listOfTouchedValues), _toConsumableArray((0, _arrayFrom2.default)(pseudoValues)));

    return (0, _lodash16.default)(valuesToPick, function (activeErrors, valuePath) {

      if (!valuePath.endsWith(_Wildcard2.default)) {
        var error = (0, _lodash6.default)(errors, valuePath);

        if (error) {
          (0, _lodash2.default)(activeErrors, valuePath, error);
        }
      }

      return activeErrors;
    }, {});
  }

  function getValueToUse(options, firstArg, secondArg, thirdArg) {
    if ((0, _lodash10.default)(options, 'value')) {
      return options.value;
    } else {
      return (options.strategy || changeHandlerStrategy || defaultChangeHandlerStrategy)(firstArg, secondArg, thirdArg);
    }
  }

  var ValidatorComponent = function (_Component) {
    _inherits(ValidatorComponent, _Component);

    function ValidatorComponent(props, context) {
      _classCallCheck(this, ValidatorComponent);

      var _this = _possibleConstructorReturn(this, (ValidatorComponent.__proto__ || Object.getPrototypeOf(ValidatorComponent)).call(this, props, context));

      _this.changeHandler = _this.changeHandler.bind(_this);
      _this.changesHandler = _this.changesHandler.bind(_this);
      _this.changeValue = _this.changeValue.bind(_this);
      _this.changeValues = _this.changeValues.bind(_this);

      _this.pushHandler = _this.pushHandler.bind(_this);
      _this.pushValue = _this.pushValue.bind(_this);
      _this.togglePushHandler = _this.togglePushHandler.bind(_this);
      _this.togglePushValue = _this.togglePushValue.bind(_this);

      _this.unshiftHandler = _this.unshiftHandler.bind(_this);
      _this.unshiftValue = _this.unshiftValue.bind(_this);
      _this.toggleUnshiftHandler = _this.toggleUnshiftHandler.bind(_this);
      _this.toggleUnshiftValue = _this.toggleUnshiftValue.bind(_this);

      _this.pullHandler = _this.pullHandler.bind(_this);
      _this.pullValue = _this.pullValue.bind(_this);

      _this.validateHandler = _this.validateHandler.bind(_this);
      _this.validate = _this.validate.bind(_this);

      _this.validateAll = _this.validateAll.bind(_this);
      _this.validateAllHandler = _this.validateAllHandler.bind(_this);

      _this.clearValidation = _this.clearValidation.bind(_this);
      _this.clearValidationState = _this.clearValidationState.bind(_this);
      _this.clearValidationAndResetValues = _this.clearValidationAndResetValues.bind(_this);
      _this.clearTouchedValues = _this.clearTouchedValues.bind(_this);

      _this.state = _extends({}, DEFAULT_STATE);
      return _this;
    }

    _createClass(ValidatorComponent, [{
      key: 'render',
      value: function render() {
        var _state = this.state,
            touchedValues = _state.touchedValues,
            values = _state.values;


        return _react2.default.createElement(ValidatedComponent, _extends({}, this.props, this._valuesWithDefaults({ values: values, touchedValues: touchedValues }), {

          errors: this._getActiveErrors(),

          changeHandler: this.changeHandler,
          changesHandler: this.changesHandler,
          changeValue: this.changeValue,
          changeValues: this.changeValues,

          pushHandler: this.pushHandler,
          pushValue: this.pushValue,
          togglePushHandler: this.togglePushHandler,
          togglePushValue: this.togglePushValue,

          unshiftHandler: this.unshiftHandler,
          unshiftValue: this.unshiftValue,
          toggleUnshiftHandler: this.toggleUnshiftHandler,
          toggleUnshiftValue: this.toggleUnshiftValue,

          pullHandler: this.pullHandler,
          pullValue: this.pullValue,

          validateHandler: this.validateHandler,
          validate: this.validate,

          validateAllHandler: this.validateAllHandler,
          validateAll: this.validateAll,

          clearValidationState: this.clearValidationState,
          clearValidation: this.clearValidation,
          clearValidationAndResetValues: this.clearValidationAndResetValues,
          clearValidationTouchedValues: this.clearTouchedValues
        }));
      }
    }, {
      key: 'pushHandler',
      value: function pushHandler(valuePath) {
        var _this2 = this;

        var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

        return function (firstArg, secondArg, thirdArg) {
          _this2.pushValue(valuePath, getValueToUse(options, firstArg, secondArg, thirdArg), options);
        };
      }
    }, {
      key: 'pushValue',
      value: function pushValue(valuePath, value) {
        var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

        this._addValue('end', valuePath, value, options);
      }
    }, {
      key: 'togglePushHandler',
      value: function togglePushHandler(valuePath) {
        var _this3 = this;

        var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

        return function (firstArg, secondArg, thirdArg) {
          _this3.togglePushValue(valuePath, getValueToUse(options, firstArg, secondArg, thirdArg), options);
        };
      }
    }, {
      key: 'togglePushValue',
      value: function togglePushValue(valuePath, value) {
        var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

        var currentValue = this._getCurrentValue(valuePath) || [];

        if (currentValue.indexOf(value) === -1) {
          this._addValue('end', valuePath, value, _extends({}, options, { allowDuplicates: false }));
        } else {
          this.pullValue(valuePath, value, _extends({}, options, { removeAllInstances: true }));
        }
      }
    }, {
      key: 'unshiftHandler',
      value: function unshiftHandler(valuePath) {
        var _this4 = this;

        var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

        return function (firstArg, secondArg, thirdArg) {
          _this4.unshiftValue(valuePath, getValueToUse(options, firstArg, secondArg, thirdArg), options);
        };
      }
    }, {
      key: 'unshiftValue',
      value: function unshiftValue(valuePath, value) {
        var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

        this._addValue('start', valuePath, value, options);
      }
    }, {
      key: 'toggleUnshiftHandler',
      value: function toggleUnshiftHandler(valuePath) {
        var _this5 = this;

        var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

        return function (firstArg, secondArg, thirdArg) {
          _this5.toggleUnshiftValue(valuePath, getValueToUse(options, firstArg, secondArg, thirdArg), options);
        };
      }
    }, {
      key: 'toggleUnshiftValue',
      value: function toggleUnshiftValue(valuePath, value) {
        var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

        var currentValue = this._getCurrentValue(valuePath) || [];

        if (currentValue.indexOf(value) === -1) {
          this._addValue('start', valuePath, value, _extends({}, options, { allowDuplicates: false }));
        } else {
          this.pullValue(valuePath, value, _extends({}, options, { removeAllInstances: true }));
        }
      }
    }, {
      key: 'pullHandler',
      value: function pullHandler(valuePath) {
        var _this6 = this;

        var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

        return function (firstArg, secondArg, thirdArg) {
          _this6.pullValue(valuePath, getValueToUse(options, firstArg, secondArg, thirdArg), options);
        };
      }
    }, {
      key: 'pullValue',
      value: function pullValue(valuePath, value) {
        var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

        var currentValue = this._getCurrentValue(valuePath) || [];

        var finalValue = function () {
          if (options.removeAllInstances) {
            return currentValue.reduce(function (memo, element) {
              if (element !== value) {
                memo.push(element);
              }

              return memo;
            }, []);
          } else {
            (0, _invariant2.default)(!(0, _lodash10.default)(options, 'index') || typeof options.index === 'number', 'pullValue\'s options.index must be a number; Received ' + options.index + ' instead');

            var index = (0, _lodash10.default)(options, 'index') ? options.index : currentValue.indexOf(value);

            if (index === -1) {
              return currentValue;
            } else {
              return [].concat(_toConsumableArray(currentValue.slice(0, index)), _toConsumableArray(currentValue.slice(index + 1)));
            }
          }
        }();

        this.changeValue(valuePath, finalValue, options);
      }
    }, {
      key: 'changeHandler',
      value: function changeHandler(valuePath) {
        var _this7 = this;

        var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

        return function (firstArg, secondArg, thirdArg) {
          _this7.changeValue(valuePath, getValueToUse(options, firstArg, secondArg, thirdArg), options);
        };
      }
    }, {
      key: 'changeValue',
      value: function changeValue(valuePath, value) {
        var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

        (0, _invariant2.default)(!Array.isArray(valuePath), 'Value path passed to changeValue was an array. If you want to change multiple values at once, use `changeValues` (pluralized) instead.');

        this.changeValues([[valuePath, value]], options);
      }
    }, {
      key: 'changesHandler',
      value: function changesHandler(changes) {
        var _this8 = this;

        var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

        return function () {
          _this8.changeValues(changes, options);
        };
      }
    }, {
      key: 'changeValues',
      value: function changeValues(changes) {
        var _ref2 = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
            _ref2$validate = _ref2.validate,
            validate = _ref2$validate === undefined ? false : _ref2$validate,
            _ref2$callback = _ref2.callback,
            callback = _ref2$callback === undefined ? _emptyFunc2.default : _ref2$callback;

        (0, _invariant2.default)(Array.isArray(changes), 'Changes must be an array of path-value pairs');

        if (validate) {

          var validatePaths = function () {
            if (validate === true) {
              return (0, _lodash24.default)(changes, function (_ref3) {
                var _ref4 = _slicedToArray(_ref3, 1),
                    valuePath = _ref4[0];

                return valuePath;
              });
            } else {
              return validate;
            }
          }();

          var nextState = this._newState({ validatePaths: validatePaths, changes: changes });

          this._validate(nextState, callback);
        } else {
          var _nextState = this._newState({ changes: changes });

          this.setState(_nextState);
        }
      }
    }, {
      key: 'validateAllHandler',
      value: function validateAllHandler() {
        var _this9 = this;

        var callback = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _emptyFunc2.default;


        return function () {
          _this9.validateAll(callback);
        };
      }
    }, {
      key: 'validateAll',
      value: function validateAll(callback) {
        this._validate(_extends({}, this.state, { validateAllValues: true }), callback);
      }
    }, {
      key: 'validateHandler',
      value: function validateHandler(validatePaths) {
        var _this10 = this;

        var callback = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : (0, _emptyFunc2.default)();


        return function () {
          _this10.validate(validatePaths, callback);
        };
      }
    }, {
      key: 'validate',
      value: function validate(validatePaths) {
        var afterValidationCallback = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _emptyFunc2.default;

        this._validate(this._newState({ validatePaths: validatePaths }), afterValidationCallback);
      }
    }, {
      key: 'clearValidationState',
      value: function clearValidationState(paths) {
        console.warn('Deprecation Warning: clearValidationState is deprecated. Please use clearValidationAndResetValues() instead.');

        this.clearValidationAndResetValues(paths);
      }
    }, {
      key: 'clearValidationAndResetValues',
      value: function clearValidationAndResetValues(paths) {
        if (paths) {
          var _state2 = this.state,
              touchedValues = _state2.touchedValues,
              validatedValues = _state2.validatedValues,
              values = _state2.values;


          var pathList = (0, _arrayFrom2.default)(paths);
          var newTouchedValues = (0, _lodash20.default)(touchedValues);
          var newValidatedValues = (0, _lodash20.default)(validatedValues);
          var newValues = (0, _lodash20.default)(values);

          (0, _lodash22.default)(pathList, function (path) {
            (0, _lodash4.default)(newTouchedValues, path);
            (0, _lodash4.default)(newValidatedValues, path);
            (0, _lodash4.default)(newValues, path);
          });

          this.setState({
            touchedValues: newTouchedValues,
            validatedValues: newValidatedValues,
            values: newValues
          });
        } else {
          this.setState(_extends({}, DEFAULT_STATE));
        }
      }
    }, {
      key: 'clearValidation',
      value: function clearValidation(paths) {

        if (paths) {
          var validatedValues = this.state.validatedValues;

          var newValidatedValues = (0, _lodash20.default)(validatedValues);

          var pathList = (0, _arrayFrom2.default)(paths);

          (0, _lodash22.default)(pathList, function (path) {
            (0, _lodash4.default)(newValidatedValues, path);
          });

          this.setState({
            validatedValues: newValidatedValues,
            validateAllValues: false
          });
        } else {

          this.setState({
            validatedValues: (0, _lodash20.default)(DEFAULT_STATE.validatedValues),
            validateAllValues: false
          });
        }
      }
    }, {
      key: 'clearTouchedValues',
      value: function clearTouchedValues() {
        this.setState({
          touchedValues: {},
          validateAllValues: false
        });
      }
    }, {
      key: '_addValue',
      value: function _addValue(position, valuePath, value, options) {
        var currentValue = this._getCurrentValue(valuePath) || [];

        var newValue = function () {
          if (options.allowDuplicates === false && currentValue.indexOf(value) !== -1) {
            return currentValue;
          }

          if (position === 'start') {
            return [value].concat(_toConsumableArray(currentValue));
          } else {
            return [].concat(_toConsumableArray(currentValue), [value]);
          }
        }();

        this.changeValue(valuePath, newValue, options);
      }
    }, {
      key: '_newState',
      value: function _newState(_ref5) {
        var validatePaths = _ref5.validatePaths,
            changes = _ref5.changes;
        var _state3 = this.state,
            validatedValues = _state3.validatedValues,
            touchedValues = _state3.touchedValues,
            values = _state3.values;


        var newValues = (0, _lodash20.default)(values);
        var newTouchedValues = (0, _lodash20.default)(touchedValues);
        var changingValues = [];

        if (changes) {
          (0, _lodash22.default)(changes, function (_ref6) {
            var _ref7 = _slicedToArray(_ref6, 2),
                path = _ref7[0],
                value = _ref7[1];

            (0, _lodash2.default)(newValues, path, value);
            (0, _lodash2.default)(newTouchedValues, path, path);
            changingValues.push(path);
          });
        }

        var newValidatedValues = function () {
          if (validatePaths) {
            var valuePathsList = (0, _arrayFrom2.default)(validatePaths);

            return (0, _mergeValidatedValuePaths2.default)(valuePathsList, validatedValues);
          } else {
            return validatedValues;
          }
        }();

        return _extends({}, this.state, {
          values: newValues,
          touchedValues: newTouchedValues,
          validatedValues: newValidatedValues,
          changingValues: changingValues
        });
      }
    }, {
      key: '_omitDeep',
      value: function _omitDeep(target, valueToOmit) {
        var _this11 = this;

        if (valueToOmit) {
          if ((0, _lodash14.default)(target)) {

            return (0, _lodash16.default)(target, function (memo, value, key) {

              if (!(0, _lodash12.default)(valueToOmit[key])) {
                memo[key] = _this11._omitDeep(value, valueToOmit[key]);
              }

              return memo;
            }, {});
          } else if (Array.isArray(target)) {

            return (0, _lodash16.default)(target, function (memo, value, index) {

              if (!(0, _lodash12.default)(valueToOmit[index])) {
                memo.push(_this11._omitDeep(value, valueToOmit[index]));
              }

              return memo;
            }, []);
          } else {
            return target;
          }
        } else {
          return target;
        }
      }
    }, {
      key: '_getActiveErrors',
      value: function _getActiveErrors() {
        var _state4 = this.state,
            errors = _state4.errors,
            validateAllValues = _state4.validateAllValues,
            touchedValues = _state4.touchedValues,
            validatedValues = _state4.validatedValues;


        var externalErrors = (0, _lodash6.default)(this.props, externalErrorsPath || 'errors', {});
        var baseErrors = this._omitDeep(externalErrors, touchedValues);

        if (validateAllValues) {
          return (0, _lodash18.default)({}, errors, baseErrors);
        } else {
          return (0, _lodash18.default)(pickErrors(errors, validatedValues), baseErrors);
        }
      }
    }, {
      key: '_valuesWithDefaults',
      value: function _valuesWithDefaults(_ref8) {
        var _this12 = this;

        var values = _ref8.values,
            touchedValues = _ref8.touchedValues;


        if (only) {
          var validateableFields = (0, _arrayFrom2.default)(only);

          var propValues = (0, _lodash16.default)(validateableFields, function (memo, path) {
            var pathSegments = path.split(/[.[]/);

            var pathRoot = pathSegments.length > 1 ? pathSegments[0] : path;

            var sourceValue = (0, _lodash6.default)(_this12.props, pathRoot);
            (0, _lodash2.default)(memo, pathRoot, sourceValue);

            return memo;
          }, {});

          var defaultValues = (0, _pickDeep2.default)(ValidatedComponent.defaultProps, validateableFields);

          var propsWithDefaults = (0, _lodash18.default)({}, propValues, defaultValues);

          return (0, _valuesWithDefaultsAndExemptions2.default)({
            defaultValue: propsWithDefaults,
            overrides: wrapObject(values),
            deepMergeExemptions: wrapObject(touchedValues)
          });
        } else {
          var _propsWithDefaults = (0, _lodash18.default)({}, this.props, ValidatedComponent.defaultProps);

          return (0, _valuesWithDefaultsAndExemptions2.default)({
            defaultValue: _propsWithDefaults,
            overrides: wrapObject(values),
            deepMergeExemptions: wrapObject(touchedValues)
          });
        }
      }
    }, {
      key: '_getCurrentValue',
      value: function _getCurrentValue(path) {
        return (0, _lodash6.default)(unwrapObject(this._valuesWithDefaults(this.state)), path);
      }
    }, {
      key: '_validate',
      value: function _validate(nextState, afterValidationCallback) {
        var _this13 = this;

        var afterValidationHandler = this._afterValidationHandler(nextState, afterValidationCallback);

        var valuesWithDefaults = unwrapObject(this._valuesWithDefaults(nextState));

        var validatorOptions = _extends({}, nextState, {
          valuesWithDefaults: valuesWithDefaults,
          touchedValues: (0, _pickOutermost2.default)(nextState.touchedValues),
          validatedValues: (0, _pickOutermost2.default)(nextState.validatedValues),
          props: _extends({}, this.props)
        });

        if (joiSchema) {
          Joi.validate(valuesWithDefaults, joiSchema, _extends({ abortEarly: false }, joiOptions), function (joiError) {
            var joiErrorList = joiError && joiError.details || [];

            var errors = (0, _lodash16.default)(joiErrorList, function (joiErrors, _ref9) {
              var message = _ref9.message,
                  path = _ref9.path;

              var messageWithFieldNameRemoved = message.replace(/^".+" /, '');

              (0, _lodash2.default)(joiErrors, path, messageWithFieldNameRemoved);

              return joiErrors;
            }, {});

            _this13._callValidatorIfDefined((0, _arrayFrom2.default)(validator), _extends({}, validatorOptions, { errors: errors
            }), afterValidationHandler);
          });
        } else {
          this._callValidatorIfDefined((0, _arrayFrom2.default)(validator), _extends({}, validatorOptions, { errors: {}
          }), afterValidationHandler);
        }
      }
    }, {
      key: '_callValidatorIfDefined',
      value: function _callValidatorIfDefined(validatorList, validatorOptions, afterValidatorHasRun) {
        var _this14 = this;

        if (validatorList.length > 0) {
          var callback = function () {
            if (validatorList.length > 1) {

              return function (_ref10) {
                var values = _ref10.values,
                    errors = _ref10.errors;


                _this14._callValidatorIfDefined((0, _lodash8.default)(validatorList), _extends({}, validatorOptions, { values: values, errors: errors
                }), afterValidatorHasRun);
              };
            } else {
              return afterValidatorHasRun;
            }
          }();

          validatorList[0](validatorOptions, callback);
        } else {
          var values = validatorOptions.values,
              errors = validatorOptions.errors;


          afterValidatorHasRun({ values: values, errors: errors });
        }
      }
    }, {
      key: '_afterValidationHandler',
      value: function _afterValidationHandler(nextState, afterValidationComplete) {
        var _this15 = this;

        return function (_ref11) {
          var errors = _ref11.errors,
              values = _ref11.values;


          var newState = _extends({}, nextState, { errors: errors, values: values
          });

          _this15.setState(newState, afterValidationComplete);
        };
      }
    }]);

    return ValidatorComponent;
  }(_react.Component);

  return ValidatorComponent;
};

ReactJoiValidation.setJoi = function (joiClass) {
  Joi = joiClass;
};

ReactJoiValidation.setChangeHandlerStrategy = function (changeHandlerStrategy) {
  defaultChangeHandlerStrategy = changeHandlerStrategy;
};

exports.default = ReactJoiValidation;